/* Program ZERLEG.Cc    */
/* By Harald Stauss     */
/* Last change 12.10.99 */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "tsa.h"

void s2hm(double sec, double *h, double *min) {
  *h=floor(sec/3600);
  *min=floor( (sec-(*h)*3600) / 60);
  while (*h>23) if (*h>23) *h-=24;
}

main(int argc, char *argv[])
{
  int            i;
  unsigned long  ni, ndata, start, start_h, start_m, seg_l, seg_s;
  double         actuell, hr_mean, bp_mean, ah, am;
  char           *fin,*ftin;
  char           *pfin, *pftin;
  REGIST   r;

  void s2hm(double sec, double *h, double *min);


  /* H e l l o   w o r l d */
  cout << "zerleg Ver.1.1 by H. Stauss, 2000 \n";

  /* A r r a y s   a l l o c i e r e n */
  fin=(char *)malloc(255); pfin=fin;
  ftin=(char *)malloc(255); pftin=ftin;

  /* P a r a m e t e r   e i n l e s e n */
  if (argc != 5)
    {
      printf("Number of parameters wrong! \n");
      printf("fin      : name of input file (*.asc,*tsa). \n");
      printf("start h  : hour of start of recording \n");
      printf("start min: minute of start of recording \n");
      printf("seg_l    : length (s) of segment \n");
      goto ende;
    }

  strcpy(fin,argv[1]);
  strcpy(ftin,fin);
  pftin=strrchr(ftin,'.');
  for (i=0; pftin[i]; i++) pftin[i]=toupper(pftin[i]);
  start_h=strtoul(argv[2],NULL,0);
  start_m=strtoul(argv[3],NULL,0);
  start=start_h*3600+start_m*60;
  seg_l=strtoul(argv[4],NULL,0);

  cout << "Input file                : " << fin << "\n";
  cout << "Time of start of recording: " << start << " s \n";
  cout << "Length of segment         : " << seg_l << " s \n";
 
  /* E i n g a b e d a t e i e n   o e f f n e n */
  if (strcmp(pftin,".TSA")==0) r.ReadTSA(fin);
  if (strcmp(pftin,".ASC")==0) r.ReadASCII(fin,1);
  if ((strcmp(pftin,".TSA")!=0) && (strcmp(pftin,".ASC")!=0)) {
    cout << "File type for input file not recognized! \n";
    goto ende;
  }
 
  cout << "Number of channels in input file: " << r.n << "\n";

  /* M A I N L O O P  */
  actuell=start;
  seg_s=((unsigned long)ceil((double)start/(double)seg_l))*seg_l;
  /* gehe zum Beginn des ersten Segments */
  ni=0;
  while (actuell<seg_s) {
    actuell+=(1.0/r.ch[0].data[ni]);
    ni++;
  }
  while (ni<r.ch[0].n) {
    hr_mean=0; bp_mean=0; ndata=0;
    s2hm(actuell, &ah, &am);
    if (ah<10) cout << "0";
    cout << ah << ":";
    if (am<10) cout << "0";
    cout << am << " ";
    s2hm(seg_s+seg_l, &ah, &am);
    if (ah<10) cout << "0";
    cout << ah << ":";
    if (am<10) cout << "0";
    cout << am <<"\t";
    while ( (actuell<(seg_s+seg_l)) && (ni<r.ch[0].n) ) {
      hr_mean+=r.ch[0].data[ni];
      bp_mean+=r.ch[1].data[ni];
      actuell+=(1.0/r.ch[0].data[ni]);
      ndata++; ni++;
    }
    cout  <<  hr_mean/ndata << "\t" << bp_mean/ndata << "\n";
    actuell=seg_s+seg_l;
    seg_s+=seg_l;
  }

 ende:
  free(fin);free(ftin);
  return(0);
} /* Ende von main */
